"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getWebpackConfig = getWebpackConfig;

function getWebpackConfig(config, extras) {
  const nuxtFilteredPlugins = ["VueSSRClientPlugin", "ExtractCSS", "HtmlWebpackPlugin", "ESLintWebpackPlugin"];
  const nuxtFilteredEntries = ["webpack-hot-middleware", ".nuxt-storybook/client.js", "eventsource-polyfill"];
  const storybookValidPlugins = ["VirtualModulesPlugin", "HtmlWebpackPlugin", "DefinePlugin"];
  config.entry = [...extras.nuxtWebpackConfig.entry.app.filter(p => !nuxtFilteredEntries.some(np => p.includes(np))), ...config.entry];

  const modules = config.plugins.find(p => p.constructor.name === "VirtualModulesPlugin")._staticModules;

  Object.keys(modules).forEach(key => {
    modules[key] = modules[key].replace(/@storybook\/vue(?!\/)/g, "~~/.nuxt-storybook/storybook/entry");
  });
  config.plugins = [...config.plugins.filter(p => storybookValidPlugins.includes(p.constructor.name)), ...extras.nuxtWebpackConfig.plugins.filter(p => !nuxtFilteredPlugins.includes(p.constructor.name))];
  const rules = config.module.rules.filter(rule => !/css|svg|mp/.test(rule.test?.toString()) && !/vue-loader/.test(String(rule.loader)));
  config.module.rules = [...rules, ...extras.nuxtWebpackConfig.module.rules];
  config.resolve.alias.vue = require.resolve("vue/dist/vue.js");
  config.resolve.alias.vue2 = require.resolve("vue/dist/vue.js");
  return config;
}